"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mock = exports.createMock = void 0;
const createMock = function () {
    const target = function () {
        return exports.createMock();
    };
    target[Symbol.toPrimitive] = () => "UniversalMock";
    return new Proxy(target, {
        set(trapTarget, key, value, receiver) {
            target[key] = value;
            return Reflect.set(trapTarget, key, value, receiver);
        },
        get(_trapTarget, key) {
            return target[key] !== undefined
                ? target[key]
                : key === "__ko_proto__"
                    ? undefined
                    : (target[key] = exports.createMock());
        },
        has(_trapTarget, key) {
            return target[key] !== undefined ? target[key] : key !== "__ko_proto__";
        },
    });
};
exports.createMock = createMock;
exports.mock = exports.createMock();
